Subject: Re: Tigon3 5701 PCI-X recv performance problem

From: John Partridge <[email-masked]>
Date: Tue, 14 Oct 2003 11:49:14 -0500

The key point for me is, as David said yesterday, SGI users will only
have to recompile the tg3 driver with the CONFIG defined to get the desired
behavior, not hte whole kernel. They just use the recompiled driver with
whatever kernel they are using. Users who use SGI propack will already
have the (static) driver with the CONFIG defined by SGI, SuSE users
who use a tg3.o use it as a module anyway, so it's not a big deal
just to recompile tg3. The only problem I can see is if users use RedHat
Advanced Server, I believe the tg3 driver is static in the kernel so they
won't be able to just recompile the tg3 driver.

I do propose that we make the CONFIG a little more descriptive something like

  CONFIG_5701PCIX_UNALIGNED_EXPENSIVE

just to make it easier for users to see what it does.

John

David S. Miller wrote:
> On Sat, 11 Oct 2003 15:19:21 +0200
> Andi Kleen <[email-masked]> wrote:
> 
> 
>>Then just don't set the argument to zero in modules.conf on the 5704cards. 
>>That could be even handled somewhere in user space.  Switching over sounds 
>>best of course, because the performance with the copying won't be great
> 
> 
> There is no "argument" we don't have a variable in the tg3 driver
> that determines the "copybreak", it's a hard-coded macro define.
> 
> For them it's really easy to know when the 5701 hw bug case is present,
> so they can do something like:
> 
> 	if (len > RX_COPY_THRESHOLD
> #ifdef CONFIG_UNALIGNED_EXPENSIVE
> 	    || tp->rx_offset == 2
> #endif
> 	    ) {
>         ...
> 
> And then only their platform and only when the buggy chips are present,
> will get the desired change in behavior.
> 

-- 
John Partridge

Silicon Graphics Inc
Tel:  651-683-3428
Vnet: 233-3428
E-Mail: [email-masked]